Declare updateScreen()

#win0=1
#menu=1
#canvas=1
#maximages=1000

Global Dim im(#maximages)
Global Dim imx(#maximages)
Global Dim imy(#maximages)
Dim img$(#maximages)
Global cpt=0
Global sel=0

If UsePNGImageDecoder()=0 Or UsePNGImageEncoder()=0
  MessageRequester("Erreur","Impossible d'initialiser le format PNG !")
  End  
EndIf

If OpenWindow(#win0,0,0,1024,768,"SpriteOffset",#PB_Window_SystemMenu | #PB_Window_ScreenCentered)=0
  MessageRequester("Erreur","Impossible d'initialiser la fentre !")
  End
EndIf

SmartWindowRefresh(#win0, #True)

If CreateMenu(#menu,WindowID(#win0))
  MenuTitle("Fichier")
  MenuItem(1, "Importer image(s)")
  MenuItem(2, "Exporter sequence d'images")
  MenuItem(3, "Exporter animation en Animstrip")
  MenuItem(4, "Quitter")
  MenuTitle("Aide")
  MenuItem(11, "Infos")
  MenuItem(12, "A propos...")
EndIf

CanvasGadget(#canvas,0,0,1024,768,#PB_Canvas_Border | #PB_Canvas_ClipMouse | #PB_Canvas_Keyboard)

Global grid=CreateImage(#PB_Any,1024,768,32)
StartDrawing(ImageOutput(grid))
c=255
For y=0 To 767 Step 16
  For x=0 To 1023 Step 16
    Box(x,y,16,16,RGBA(c,c,c,255))
    If c=255
      c=192
    Else
      c=255
    EndIf
  Next
  If c=255
    c=192
  Else
    c=255
  EndIf
Next
StopDrawing()

updateScreen()
SetActiveGadget(#canvas)

take=0

Repeat
  
  
  we=WindowEvent()
  
  Select we
    Case #PB_Event_Menu
      em=EventMenu()
      Select em
        Case 1
          If cpt<#maximages
            cpt=cpt+1
            NomFichier$=OpenFileRequester("Importer image(s)","","",0,#PB_Requester_MultiSelection)
            If NomFichier$<>"" And LCase(Right(NomFichier$,3))="png"
              While NomFichier$<>""
                im(cpt)=LoadImage(#PB_Any,NomFichier$)
                imx(cpt)=0
                imy(cpt)=0
                img$(cpt)=NomFichier$
                NomFichier$ = NextSelectedFileName()
                If NomFichier$<>""
                  cpt=cpt+1
                EndIf
                If cpt>#maximages
                  cpt=#maximages
                  Break
                EndIf
              Wend
              sel=1
              UpdateScreen()
            Else
              cpt=cpt-1
              If NomFichier$<>""
                MessageRequester("Erreur","Seuls les fichiers 'Png' sont autoriss !")
              EndIf
            EndIf
          EndIf
        Case 2
          If cpt>0
            p$=PathRequester("Choisissez le rpertoire d'exportation des images","")
            If p$<>""
              xleft=imx(1)
              xright=imx(1)+ImageWidth(im(1))-1
              yup=imy(1)
              ydown=imy(1)+ImageHeight(im(1))-1
              If xleft<0
                xleft=0
              EndIf
              If yup<0
                yup=0
              EndIf
              If xright>1023
                xright=1023
              EndIf
              If ydown>767
                ydown=767
              EndIf
              For i=2 To cpt
                If imx(i)<xleft
                  xleft=imx(i)
                EndIf
                If imx(i)+ImageWidth(im(i))-1>xright
                  xright=imx(i)+ImageWidth(im(i))-1
                EndIf
                If imy(i)<yup
                  yup=imy(i)
                EndIf
                If imy(i)+ImageHeight(im(i))-1>ydown
                  ydown=imy(i)+ImageHeight(im(i))-1
                EndIf
                If xleft<0
                  xleft=0
                EndIf
                If yup<0
                  yup=0
                EndIf
                If xright>1023
                  xright=1023
                EndIf
                If ydown>767
                  ydown=767
                EndIf
                tempimg=CreateImage(#PB_Any,1024,768,32 | #PB_Image_Transparent)
                StartDrawing(ImageOutput(tempimg))
                DrawingMode(#PB_2DDrawing_AllChannels)
                DrawAlphaImage(ImageID(im(i)),imx(i),imy(i))
                StopDrawing()
                StartDrawing(ImageOutput(tempimg))
                xl=xleft
                For y=0 To 767
                  For x=0 To xl
                    If Alpha(Point(x,y))>0
                      If x<xleft
                        xleft=x
                      EndIf
                    EndIf
                  Next
                Next
                xr=xright
                For y=0 To 767
                  For x=1023 To xr Step -1
                    If Alpha(Point(x,y))>0
                      If x>xright
                        xright=x
                      EndIf
                    EndIf
                  Next
                Next
                yu=yup
                For x=0 To 1023
                  For y=0 To yu
                    If Alpha(Point(x,y))>0
                      If y<yup
                        yup=y
                      EndIf
                    EndIf
                  Next
                Next
                yd=ydown
                For x=0 To 1023
                  For y=767 To yd Step -1
                    If Alpha(Point(x,y))>0
                      If y>ydown
                        ydown=y
                      EndIf
                    EndIf
                  Next
                Next
                StopDrawing()
              Next
              For i=1 To cpt
                tempimg=CreateImage(#PB_Any,1024,768,32 | #PB_Image_Transparent)
                StartDrawing(ImageOutput(tempimg))
                DrawingMode(#PB_2DDrawing_AllChannels)
                DrawAlphaImage(ImageID(im(i)),imx(i),imy(i))
                StopDrawing()
                tempimg2=GrabImage(tempimg,#PB_Any,xleft,yup,xright-xleft+1,ydown-yup+1)
                SaveImage(tempimg2,p$+GetFilePart(img$(i)),#PB_ImagePlugin_PNG)
                FreeImage(tempimg2)
                FreeImage(tempimg)
              Next
            EndIf
          EndIf
        Case 3
          If cpt>1
            p$=SaveFileRequester("Choisissez le fichier animstrip  exporter","","",0)
            If GetExtensionPart(p$)=""
              p$=p$+".png"
            EndIf
            If p$<>"" And LCase(Right(p$,3))="png"
              xleft=imx(1)
              xright=imx(1)+ImageWidth(im(1))-1
              yup=imy(1)
              ydown=imy(1)+ImageHeight(im(1))-1
              If xleft<0
                xleft=0
              EndIf
              If yup<0
                yup=0
              EndIf
              If xright>1023
                xright=1023
              EndIf
              If ydown>767
                ydown=767
              EndIf
              For i=2 To cpt
                If imx(i)<xleft
                  xleft=imx(i)
                EndIf
                If imx(i)+ImageWidth(im(i))-1>xright
                  xright=imx(i)+ImageWidth(im(i))-1
                EndIf
                If imy(i)<yup
                  yup=imy(i)
                EndIf
                If imy(i)+ImageHeight(im(i))-1>ydown
                  ydown=imy(i)+ImageHeight(im(i))-1
                EndIf
                If xleft<0
                  xleft=0
                EndIf
                If yup<0
                  yup=0
                EndIf
                If xright>1023
                  xright=1023
                EndIf
                If ydown>767
                  ydown=767
                EndIf
                tempimg=CreateImage(#PB_Any,1024,768,32 | #PB_Image_Transparent)
                StartDrawing(ImageOutput(tempimg))
                DrawingMode(#PB_2DDrawing_AllChannels)
                DrawAlphaImage(ImageID(im(i)),imx(i),imy(i))
                StopDrawing()
                StartDrawing(ImageOutput(tempimg))
                xl=xleft
                For y=0 To 767
                  For x=0 To xl
                    If Alpha(Point(x,y))>0
                      If x<xleft
                        xleft=x
                      EndIf
                    EndIf
                  Next
                Next
                xr=xright
                For y=0 To 767
                  For x=1023 To xr Step -1
                    If Alpha(Point(x,y))>0
                      If x>xright
                        xright=x
                      EndIf
                    EndIf
                  Next
                Next
                yu=yup
                For x=0 To 1023
                  For y=0 To yu
                    If Alpha(Point(x,y))>0
                      If y<yup
                        yup=y
                      EndIf
                    EndIf
                  Next
                Next
                yd=ydown
                For x=0 To 1023
                  For y=767 To yd Step -1
                    If Alpha(Point(x,y))>0
                      If y>ydown
                        ydown=y
                      EndIf
                    EndIf
                  Next
                Next
                StopDrawing()
              Next
              memi=1
              memj=cpt
              iwidth=xright-xleft+1
              iheight=ydown-yup+1
              animstrip=CreateImage(#PB_Any,memi*iwidth,memj*iheight,32 | #PB_Image_Transparent)
              i=1
              For y=1 To memj
                For x=1 To memi
                  If i<=cpt
                    tempimg=CreateImage(#PB_Any,1024,768,32 | #PB_Image_Transparent)
                    StartDrawing(ImageOutput(tempimg))
                    DrawingMode(#PB_2DDrawing_AllChannels)
                    DrawAlphaImage(ImageID(im(i)),imx(i),imy(i))
                    StopDrawing()
                    tempimg2=GrabImage(tempimg,#PB_Any,xleft,yup,iwidth,iheight)
                    StartDrawing(ImageOutput(animstrip))
                    DrawingMode(#PB_2DDrawing_AllChannels)
                    DrawAlphaImage(ImageID(tempimg2),(x-1)*iwidth,(y-1)*iheight)
                    StopDrawing()
                    FreeImage(tempimg2)
                    FreeImage(tempimg)
                  EndIf
                  i=i+1
                Next
              Next
              SaveImage(animstrip,p$,#PB_ImagePlugin_PNG)
              FreeImage(animstrip)
            Else
              If p$<>""
                MessageRequester("Erreur","Seuls les fichiers 'Png' sont autoriss !")
              EndIf
            EndIf
          EndIf
        Case 4
          Break
        Case 11
          MessageRequester("Infos","Un fois vos images importes, slectionnez-les avec la molette de la souris. Ensuite, dplacez-les l o vous voulez avec le bouton gauche appuy, ou en appuyant sur les flches du clavier. Enfin, exportez le tout...")
        Case 12
          MessageRequester("A propos...","Freeware Open Source Programm par B.Vignoli")
      EndSelect
    Case #PB_Event_CloseWindow
      Break
    Case #PB_Event_Gadget
      eg=EventGadget()
      et=EventType()
      If eg=#canvas
        If et=#PB_EventType_LostFocus
          SetActiveGadget(#canvas)
        EndIf
        If et=#PB_EventType_MouseWheel
          mw=GetGadgetAttribute(#canvas,#PB_Canvas_WheelDelta)
          If cpt>0
            sel=sel-mw
            While sel<1
              sel=sel+cpt
            Wend
            While sel>cpt
              sel=sel-cpt
            Wend
            UpdateScreen()
          EndIf
        EndIf
        If et=#PB_EventType_LeftButtonDown Or (et=#PB_EventType_MouseMove And GetGadgetAttribute(#canvas,#PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
          If cpt>0 And sel>0
            If take=0
              take=1
              xt = GetGadgetAttribute(#canvas, #PB_Canvas_MouseX)
              yt = GetGadgetAttribute(#canvas, #PB_Canvas_MouseY)
              oldxt=xt
              oldyt=yt
            Else
              xt = GetGadgetAttribute(#canvas, #PB_Canvas_MouseX)
              yt = GetGadgetAttribute(#canvas, #PB_Canvas_MouseY)
              imx(sel)=imx(sel)+xt-oldxt
              imy(sel)=imy(sel)+yt-oldyt
              UpdateScreen()           
              oldxt=xt
              oldyt=yt
            EndIf
          EndIf
        Else
          take=0
        EndIf
        If et=#PB_EventType_KeyDown
          mw=GetGadgetAttribute(#canvas,#PB_Canvas_Key)
          If cpt>0 And sel>0
            If mw=#PB_Shortcut_Up
              imy(sel)=imy(sel)-1
              UpdateScreen()
            EndIf
            If mw=#PB_Shortcut_Down
              imy(sel)=imy(sel)+1
              UpdateScreen()
            EndIf
            If mw=#PB_Shortcut_Right
              imx(sel)=imx(sel)+1
              UpdateScreen()
            EndIf
            If mw=#PB_Shortcut_Left
              imx(sel)=imx(sel)-1
              UpdateScreen()
            EndIf
          EndIf
        EndIf
      EndIf
    Default
      Delay(1)
  EndSelect
  
ForEver

CloseWindow(#win0)

End

Procedure UpdateScreen()
  If cpt>0 And sel>0
    SetWindowTitle(#win0,"SpriteOffset   ... "+Str(sel))
  Else
    SetWindowTitle(#win0,"SpriteOffset")
  EndIf
  tempimg=CreateImage(#PB_Any,1024,768,32)
  StartDrawing(ImageOutput(tempimg))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(grid),0,0)
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  If sel>0
    DrawAlphaImage(ImageID(im(sel)),imx(sel),imy(sel))
  EndIf
  StopDrawing()
  StartDrawing(CanvasOutput(#canvas))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(tempimg),0,0)
  StopDrawing()
  FreeImage(tempimg)
EndProcedure

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 128
; FirstLine = 128
; Folding = -
; EnableXP
; UseIcon = icone.ico
; Executable = SpriteOffset.exe